;===============================================================
;WM_CHAR message/key handler code
;===============================================================
;NOTE: For all general movement keys, the game DOES NOT process
;the WM_KEYDOWN, WM_KEYUP, or WM_CHAR messages.
;
;-> General movement keys are scanned using a call to GetAsyncKeyState,
; referenced nearest to the end of the executable (005DBCE2 for
; P6 1.1 exe).
;-> Console/command-line (i.e., saving) keys are processed from
; the WM_CHAR message.
;-> General system keys (ESC, PrintScreen, F11, etc.) are scanned
; from the WM_KEYDOWN message.
;===============================================================
MACRO TESTKEY sourcekey,destjump {
    local NoKey
    cmp sourcekey,0
	jz NoKey
    cmp eax,sourcekey
	jz destjump
    NoKey:
	}
;===============================================================
MAIN_KEYHANDLER:	;WNDPROC params start at [esp+10h]
movsx edx,WORD [esp+1Ch]	;replaced code
mov eax,[esp+18h]		;replaced code (eax=wparam=char)
push eax
push ecx
push edx

cmp [IsInGame_BOOL],0
     jz MAIN_KEYHANDLER_EXIT
cmp [IsInConsole_BOOL],1
     jz MAIN_KEYHANDLER_EXIT

	TESTKEY [UseToggleNewKeys],ToggleNewKeys_359324
	cmp [ToggleNewKeys_BOOL],0
	    jz NoNewKeys_43554
	TESTKEY [UseUserMapKey],ToggleMap_43545
	TESTKEY [UseUserMDinoKey],ToggleMDinos_4324
	TESTKEY [UseDrawDistSubKey],SubstractFromDrawDist_343
	TESTKEY [UseDrawDistAddKey],AddToDrawDist_343
	TESTKEY [UseCANIMALKey],ShowCANIMALCHEAT_3443
	TESTKEY [UseUserMSelKey],ShowMSELCHEAT_3443
	TESTKEY [UseUserCANIMALLEFTKey],CANIMAL_LEFT_3443
	TESTKEY [UseUserCANIMALRIGHTKey],CANIMAL_RIGHT_3443
NoNewKeys_43554:

       ; call TestForFlyModeKeys

cmp al,"i"
    jz asdfsdfsdf

MAIN_KEYHANDLER_EXIT:
pop edx
pop ecx
pop eax
ret

asdfsdfsdf:
db "CRASH"
;===============================================================
ToggleNewKeys_359324:
	xor [ToggleNewKeys_BOOL],1
	invoke GetTickCount
	mov [ToggleKeysShowStateTime],eax
	;...
;===============================================================
EXITKEYHANDLER:
	pop edx
	pop ecx
	pop eax
	add esp,4		;get rid of return address
	pop edi
	xor eax,eax
	pop esi
	ret 10h

EXITKEYHANDLER_PASSIVE:
	pop edx
	pop ecx
	pop eax
	ret
;===============================================================
ToggleMap_43545:
	xor [USE_MAP],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ToggleMDinos_4324:
	xor [ShowDinosOnMap_BOOL],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
SubstractFromDrawDist_343:
	push DWORD -1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
AddToDrawDist_343:
	push DWORD 1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ShowCANIMALCHEAT_3443:
	xor [DisplayDinoInfo_BOOL],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ShowMSELCHEAT_3443:
	xor [ShowActiveDinoOnMap_BOOL],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
CANIMAL_LEFT_3443:
	call CYCLEDINOINFOLEFT_PROC
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
CANIMAL_RIGHT_3443:
	call CYCLEDINOINFORIGHT_PROC
jmp EXITKEYHANDLER_PASSIVE
;===============================================================