;=======================================================
;checks level info before modifying
;=======================================================
Modify_External:
	call VerifyCAnimalBuffers
	     test eax,eax
		  jz No_Modify_934579483543
	call IsLevelSavedGame
	     test eax,eax
		  jnz No_Modify_934579483543
	call ModifyCAnimalInstances
	call SetRandomDinoStartPositions
No_Modify_934579483543:
	call CreateDinoInitialInfo

mov [CounterFirstRun],1
mov [NewLevel_BOOL],1
mov [New_CAnimal_BUF],1 	;create new buffer next time
and [HINT_NEW_STRING_ADDR],0

	mov eax,[CAnimal_BUF_SIZE]
	shr eax,2		;set number of instances string for "CANIMAL" cheat
invoke wsprintf,canimal_title,canimal_title_base,eax
       add esp,12
       mov [canimal_title_size],eax

call FLY_CLOAK_Cheats_Reset
call EnableInGameKeys

ret

;=======================================================
FLY_CLOAK_Cheats_Reset:   ;eax=0 if buffers not OK
;=======================================================
	and [FLY_MODE_BOOL],0

	mov esi,[BaseData]
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;edx = main "Player" class object

	and BYTE [edx+0DDh],0FEh	;disable INVUL

	push 5
	call CHANGEPLAYERTYPE_PROC

EXIT_CHANGEPLAYERTYPE_12322:
ret

;=======================================================
VerifyCAnimalBuffers:	;eax=0 if buffers not OK
;=======================================================
;Note: I don't know the exact size of CAnimal class. This
;routine could be optimized if this size was known.

	mov esi,[BaseData]
	mov esi,[CANIMAL_VTABLE]
	mov edi,[CAnimal_BUF]
	test edi,edi
	    jz BuffersNotOKorEmpty
	mov ebx,[CAnimal_BUF_SIZE]
	test ebx,ebx
	    jz BuffersNotOKorEmpty
	add ebx,edi

TestCAnimalBuffersMainLoop:

invoke IsBadReadPtr,[edi],0E0h
       test eax,eax
	    jnz BuffersNotOKorEmpty

invoke IsBadWritePtr,[edi],0E0h
       test eax,eax
	    jnz BuffersNotOKorEmpty

       mov eax,[edi]
       cmp [eax],esi		;check if proper VTable is set
	   jnz BuffersNotOKorEmpty

add edi,4
cmp edi,ebx
    jb TestCAnimalBuffersMainLoop

or al,1
ret

BuffersNotOKorEmpty:
LOCALRELEASE [CAnimal_BUF]
LOCALRELEASE [CAnimal_Names_INDEX]
LOCALRELEASE [CAnimal_Names_BUF]
       and [CAnimal_BUF_SIZE],0
       and [CAnimal_Names_BUF_SIZE],0
xor eax,eax
ret

;=======================================================
CreateDinoInitialInfo:
;=======================================================
LOCALRELEASE [CAnimal_Initial_Info]
and [CAnimal_Initial_Info],0

cmp [CAnimal_BUF],0
    jz NoCreateDinoInitialInfo
mov ebx,[CAnimal_BUF_SIZE]
    test ebx,ebx
	 jz NoCreateDinoInitialInfo

lea ecx,[ebx*8]   ;ecx=(number of instances*4)*8


invoke LocalAlloc,LMEM_FIXED,ecx   ;ecx=(number of instances)*(32 bytes/instance)
       test eax,eax
	    jz NoCreateDinoInitialInfo
mov [CAnimal_Initial_Info],eax

mov edi,eax		      ;Init_info index
mov edx,[CAnimal_BUF]	      ;CAnimal base index
add ebx,edx		      ;limit

CreateDinoInitialInfo_Main_Loop:
	mov esi,[edx]
	add esi,30h
	mov ecx,8
	rep movsd
add edx,4
cmp edx,ebx
    jb CreateDinoInitialInfo_Main_Loop

NoCreateDinoInitialInfo:
ret