;============================================================
SetRandomDinoStartPositions:
;============================================================
;NOTE: there are 6 position values per CAnimal class. I do not
;know which ones are used in which circumstances; in turn,
;this code simply updates them all.

;[ebp-150] = number of ENTRY sections
;[ebp-146] = bool buffer
;[ebp-142] = number of ENTRY sections (variable)

MACRO WRITEPOS disp1 {		;writes 5 last position values
       mov [esi+110h+disp1],eax
       mov [esi+170h+disp1],eax
       mov [esi+1D0h+disp1],eax
       mov [esi+230h+disp1],eax
       mov [esi+290h+disp1],eax
       }

cmp [UseRandomDinoLocations],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_BUF],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_BUF_SIZE],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_Names_INDEX],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_Names_BUF],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_Names_BUF_SIZE],0
    jz NoSetRandomDinoStartPositions

push ebp
mov ebp,esp
sub esp,250

   mov esi,[BaseData]
   mov esi,[LEVELNAME_OBJ]	    ;SCN level name

   mov edi,MapsDirBuffer
   add edi,[MapsPathSize]
   mov DWORD [edi],'RAN\'	    ;'RAN\' folder
   add edi,4

AppendSCNNameLoop_RAND:
	mov al,[esi]
	mov [edi],al		 ;transfer/append string
	test al,al
	     jz EndAppendSCNNameLoop_RAND
	inc edi
	inc esi
	jmp AppendSCNNameLoop_RAND
EndAppendSCNNameLoop_RAND:

	mov DWORD [edi-4],'.INI'	;modify extension
	mov esi,[BaseData]

	lea eax,[ebp-100]
invoke FindFirstFile,MapsDirBuffer,eax	;test if INI exists
	cmp eax,-1
	    jz FileNotFound_RAND
invoke FindClose,eax
				 ;get number of ENTRY sections
invoke GetPrivateProfileInt,MAIN_SECTION,ENTRY_COUNT,1500000,MapsDirBuffer
	cmp eax,1500000
	jz FileNotFound_RAND
	mov [ebp-150],eax
	mov [ebp-142],eax
	invoke LocalAlloc,LPTR,eax	;boolean buffer for ENTRYs
	       test eax,eax
		    jz FileNotFound_RAND
	mov [ebp-146],eax

	call RANDOMIZE_RANDOM_PROC
	xor ebx,ebx
	call MainDinoRandomizeProc

	invoke LocalFree,[ebp-146]

FileNotFound_RAND:
mov esp,ebp
pop ebp
mov ecx,[MapsPathSize]
mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
NoSetRandomDinoStartPositions:
ret

;============================================================
MainDinoRandomizeProc:	;ebx=Instance specifier/count
			;ebp-100 = instance name addr
			;ebp-200 = "Reserved" string
;============================================================
add ebx,1

	lea edx,[ebp-50]
invoke wsprintf,edx,INSTANCE_STRING,ebx
	add esp,12

	lea edx,[ebp-50]
	lea eax,[ebp-100]      ;get associated instance's name
invoke GetPrivateProfileString,MAIN_SECTION,edx,NULL_STRING,\
		eax,50,MapsDirBuffer
	cmp DWORD [ebp-100],'NULL'
	    jz EndMainDinoRandomizeProc

	lea edx,[ebp-50]
invoke wsprintf,edx,RESERVE_STRING,ebx
	add esp,12

	lea edx,[ebp-50]
	lea eax,[ebp-200]	;get "reserved" section for instance
invoke GetPrivateProfileString,MAIN_SECTION,edx,NULL_STRING,\
		eax,50,MapsDirBuffer
	cmp DWORD [ebp-200],'NULL'
	    jnz UseSpecificSection_RAND

	call GetRandomEntry_RAND
	     test eax,eax
		  jz MainDinoRandomizeProc   ;no more available ENTRY sections?

	lea edx,[ebp-200]		;print ENTRY section to ebp-200
invoke wsprintf,edx,ENTRY_STRING,eax
	add esp,12

UseSpecificSection_RAND:
	call RANDOMIZE_RANDOM_PROC
	call SetRandomLocationFinal
jmp MainDinoRandomizeProc

EndMainDinoRandomizeProc:
ret

;============================================================
GetRandomEntry_RAND: ;returns random entry below or equal to [ebp-150]
;============================================================
cmp DWORD [ebp-142],0
    jz NoGetRandomEntry_RAND
cmp DWORD [ebp-150],0
    jz NoGetRandomEntry_RAND

     push DWORD [ebp-150]
call GetRandomNumber
     mov ecx,[ebp-146]
     cmp BYTE [eax+ecx-1],0
	 jz GetRandomNumberSuccess

WaitForFreeENTRY_RAND:
     cmp eax,[ebp-150]
	 jb NotEndOfList_RAND
     xor eax,eax
     NotEndOfList_RAND:
     inc eax
     cmp BYTE [eax+ecx-1],0
	 jnz WaitForFreeENTRY_RAND

GetRandomNumberSuccess:
	or BYTE [eax+ecx-1],1
	dec DWORD [ebp-142]
ret

NoGetRandomEntry_RAND:
	xor eax,eax
ret		     ;returns eax=0 if no more available ENTRYs

;============================================================
SetRandomLocationFinal: ;section specified at [ebp-200]
;============================================================
       lea edx,[ebp-200]
invoke GetPrivateProfileInt,edx,ENTRIES_STRING,0,MapsDirBuffer
       cmp eax,0
	   jz NoSetRandomLocationFinal

       push eax
       call GetRandomNumber

       lea edx,[ebp-250]	;get Location# string
invoke wsprintf,edx,LOCATION_STRING,eax
       add esp,12

       lea eax,[ebp-200]
       lea edx,[ebp-250]
       lea ecx,[ebp-50] 	;replaces previous string
invoke GetPrivateProfileString,eax,edx,NULL_STRING,ecx,\
		50,MapsDirBuffer	;get location float values

       cmp DWORD [ebp-50],'NULL'
	   jz NoSetRandomLocationFinal

       call GetCurrentInstanceObject
       test eax,eax
	    jz NoSetRandomLocationFinal

       mov esi,eax
       add eax,30h
       lea edx,[eax+4]
       lea ecx,[eax+8]

       lea edi,[ebp-50] 	;write first positions values
invoke sscanf,edi,FLOAT_RETRIEVE_STRING,eax,edx,ecx
       add esp,20

       mov eax,[esi+30h]	;write the 5 other position variables
       WRITEPOS 0
       mov eax,[esi+34h]
       WRITEPOS 4
       mov eax,[esi+38h]
       WRITEPOS 8

;============================================================
       lea edx,[ebp-200]
invoke GetPrivateProfileFloat,edx,STAYNEARMAX_STRING,MapsDirBuffer
       test eax,eax
	    jz NoSetStayNearMaxForcedValue

       mov edx,[esi+0DCh]   ;get sub-instance in instance (list of AI classes)
       mov edx,[edx+68h]    ;get ActStayNear instance
       mov [edx+64h],eax    ;set new StayNearMax value

NoSetStayNearMaxForcedValue:

       lea edx,[ebp-200]
invoke GetPrivateProfileFloat,edx,STAYNEAROK_STRING,MapsDirBuffer
       test eax,eax
	    jz NoSetStayNearOKForcedValue

       mov edx,[esi+0DCh]   ;get sub-instance in instance (list of AI classes)
       mov edx,[edx+68h]    ;get ActStayNear instance
       mov [edx+68h],eax    ;set new StayNearOK value

NoSetStayNearOKForcedValue:  ;2A68=staynearmax, 2A70=staynearok

NoSetRandomLocationFinal:
ret

;============================================================
GetCurrentInstanceObject:	;returns in eax, uses [ebp-100]
;============================================================
xor edi,edi
GetCurrentInstanceObject_LOOP:

mov eax,[CAnimal_Names_INDEX]
mov edx,[eax+edi]
add edx,[CAnimal_Names_BUF]	;edx=instance name from EXE (current)
lea esi,[ebp-100]		;esi=instance name from INI

	StringScanLoop_RAND:
	mov al,[esi]
	mov cl,[edx]
	    cmp al,cl
		jnz END_StringScanLoop_RAND
	    test al,al
		 jz Instance_Found_RAND
	inc esi
	inc edx
	jmp StringScanLoop_RAND

END_StringScanLoop_RAND:
add edi,4
cmp edi,[CAnimal_BUF_SIZE]
    jb GetCurrentInstanceObject_LOOP
xor eax,eax
ret

Instance_Found_RAND:
mov edx,[CAnimal_BUF]
mov eax,[edx+edi]
ret
